using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Text;
using Microsoft.DirectX;
using Microsoft.DirectX.Direct3D;

namespace TDCG
{
/// <summary>
/// TPOt@C̃XgłB
/// </summary>
public class TPOFileList
{
    /// TPOt@CXg
    public List<TPOFile> files = new List<TPOFile>();

    //[Vslێt[z
    private TMOFrame[] frames;

    private TMOFile tmo = null;

    /// <summary>
    /// CfNT
    /// </summary>
    /// <param name="i">index</param>
    /// <returns>tpo</returns>
    public TPOFile this[int i]
    {
        get
        {
            return files[i];
        }
    }

    /// <summary>
    /// vf
    /// </summary>
    public int Count
    {
        get
        {
            return files.Count;
        }
    }
    
    /// <summary>
    /// tpoǉ܂B
    /// </summary>
    /// <param name="tpo"></param>
    public void Add(TPOFile tpo)
    {
        tpo.Tmo = tmo;
        files.Add(tpo);
    }

    /// <summary>
    /// Xg܂B
    /// </summary>
    public void Clear()
    {
        files.Clear();
    }

    /// <summary>
    /// ̌^Xgݒ肵܂B
    /// </summary>
    /// <param name="pro_list">̌^Xg</param>
    public void SetProportionList(List<IProportion> pro_list)
    {
        Clear();
        foreach (IProportion pro in pro_list)
        {
            TPOFile tpo = new TPOFile();
            tpo.Proportion = pro;
            Add(tpo);
        }
    }

    /// <summary>
    /// Tpo.TmoɊ܂܂郂[Vslό`܂B
    /// </summary>
    public void Transform()
    {
        LoadMatrix();
        foreach (TPOFile tpo in files)
            tpo.Transform();
    }

    /// <summary>
    /// wԍ̃t[Ɋ܂܂郂[Vslό`܂B
    /// </summary>
    /// <param name="i">t[ԍ</param>
    /// <param name="frame_count">t[</param>
    public void Transform(int i, int frame_count)
    {
        LoadMatrix();
        foreach (TPOFile tpo in files)
            tpo.Transform(i, frame_count);
    }

    /// <summary>
    /// tmo
    /// </summary>
    public TMOFile Tmo
    {
        get
        {
            return tmo;
        }
        set
        {
            tmo = value;

            foreach (TPOFile tpo in files)
                tpo.Tmo = tmo;

            CreateFrames();
            SaveMatrix();
        }
    }

    //[Vslێ̈mۂB
    private void CreateFrames()
    {
        if (tmo.frames == null)
            return;

        int frame_count = tmo.frames.Length;
        frames = new TMOFrame[frame_count];
        for (int i = 0; i < frame_count; i++)
        {
            int matrix_count = tmo.frames[i].matrices.Length;
            frames[i] = new TMOFrame();
            frames[i].id = i;
            frames[i].matrices = new TMOMat[matrix_count];
            for (int j = 0; j < matrix_count; j++)
            {
                frames[i].matrices[j] = new TMOMat();
            }
        }
    }

    /// <summary>
    /// ޔ[Vsltmoɖ߂܂B
    /// </summary>
    public void LoadMatrix()
    {
        if (frames == null)
            return;

        if (tmo.frames == null)
            return;

        int frame_count = frames.Length;
        for (int i = 0; i < frame_count; i++)
        {
            int matrix_count = frames[i].matrices.Length;
            for (int j = 0; j < matrix_count; j++)
                tmo.frames[i].matrices[j].m = frames[i].matrices[j].m;
        }
    }

    /// <summary>
    /// [Vsltmoޔ܂B
    /// </summary>
    public void SaveMatrix()
    {
        if (frames == null)
            return;

        if (tmo.frames == null)
            return;

        int frame_count = frames.Length;
        for (int i = 0; i < frame_count; i++)
        {
            int matrix_count = frames[i].matrices.Length;
            for (int j = 0; j < matrix_count; j++)
                frames[i].matrices[j].m = tmo.frames[i].matrices[j].m;
        }
    }
}

    /// <summary>
    /// TPOt@C܂B
    /// </summary>
public class TPOFile
{
    private float ratio = 0.0f;
    private TMOFile tmo = null;
    private Dictionary<string, TPONode> nodemap = new Dictionary<string, TPONode>();
    private IProportion proportion = null;

    /// <summary>
    /// bonez
    /// </summary>
    public TPONode[] nodes;

    /// <summary>
    /// TPONode̕ό`Wɏ悸ό`䗦
    /// </summary>
    public float Ratio
    {
        get { return ratio; } set { ratio = value; }
    }

    /// <summary>
    /// tmo
    /// </summary>
    public TMOFile Tmo
    {
        get
        {
            return tmo;
        }

        set
        {
            nodemap.Clear();
            nodes = null;

            tmo = value;

            if (tmo == null)
                return;

            if (tmo.nodes == null)
                return;

            int node_count = tmo.nodes.Length;
            nodes = new TPONode[node_count];

            //tmo nodename𓾂Đݒ肷B
            //nodemapɒǉB
            for (int i = 0; i < node_count; i++)
            {
                string name = tmo.nodes[i].Name;
                nodes[i] = new TPONode(i, name);
                nodemap.Add(name, nodes[i]);
            }

            //eq֌Wݒ肷B
            for (int i = 0; i < node_count; i++)
            {
                int index = nodes[i].Name.LastIndexOf('|');
                if (index <= 0)
                    continue;
                string pname = nodes[i].Name.Substring(0, index);
                nodes[i].parent = nodemap[pname];
                nodes[i].parent.children.Add(nodes[i]);
            }

            ExecuteProportion();
        }
    }

    /// <summary>
    /// tpo𐶐܂B
    /// </summary>
    public TPOFile()
    {
    }

    /// <summary>
    /// ̌^
    /// </summary>
    public IProportion Proportion { get { return proportion; } set { proportion = value; }}

    /// <summary>
    /// ̌^̖O𓾂܂B
    /// </summary>
    public string ProportionName
    {
        get { return proportion.ToString(); }
    }

    /// <summary>
    /// TPONodeɕό`Wݒ肵܂B
    /// </summary>
    public void ExecuteProportion()
    {
        if (proportion == null)
            return;

        Dictionary<string, TPONode> nodemap = new Dictionary<string, TPONode>();
        foreach (TPONode node in nodes)
            nodemap[node.ShortName] = node;

        proportion.Nodes = nodemap;
        //TPONodeɕό`Wݒ肷B
        try
        {
            proportion.Execute();
        }
        catch (KeyNotFoundException)
        {
            /* not found */
        }
    }

    /// <summary>
    /// Tpo.TmoɊ܂܂郂[Vslό`܂B
    /// </summary>
    public void Transform()
    {
        if (tmo.frames == null)
            return;

        int frame_count = tmo.frames.Length;
        for (int i = 0; i < frame_count; i++)
        {
            Transform(i, frame_count);
        }
    }

    /// <summary>
    /// wԍ̃t[Ɋ܂܂郂[Vslό`܂B
    /// </summary>
    /// <param name="i">t[ԍ</param>
    /// <param name="frame_count">t[</param>
    public void Transform(int i, int frame_count)
    {
        if (tmo.frames == null)
            return;

        int matrix_count = tmo.frames[i].matrices.Length;
        int frame_mid = frame_count / 2;
        if (frame_mid != 0)
        {
            for (int j = 0; j < matrix_count; j++)
            {
                TPONode node = nodes[j];
                Debug.Assert(node != null, "node should not be null j=" + j.ToString());
                TMOMat mat = tmo.frames[i].matrices[j];//ό`Ώۃ[Vs
                float power;
                if ((i / frame_mid) % 2 == 0)
                    power = (i % frame_mid) / (float)frame_mid;
                else
                    power = (frame_mid - (i % frame_mid) - 1) / (float)frame_mid;
                node.Transform(mat, ratio * power);
            }
        }
        else
        {
            for (int j = 0; j < matrix_count; j++)
            {
                TPONode node = nodes[j];
                Debug.Assert(node != null, "node should not be null j=" + j.ToString());
                TMOMat mat = tmo.frames[i].matrices[j];//ό`Ώۃ[Vs
                node.Transform(mat, ratio);
            }
        }
    }
}

/// <summary>
/// ^Cv
/// </summary>
public enum TPOCommandType
{
    /// <summary>
    /// g
    /// </summary>
    Scale,
    /// <summary>
    /// giqbone͂ꂼkj
    /// </summary>
    Scale1,
    /// <summary>
    /// k
    /// </summary>
    Scale0,
    /// <summary>
    /// X]
    /// </summary>
    RotateX,
    /// <summary>
    /// Y]
    /// </summary>
    RotateY,
    /// <summary>
    /// Z]
    /// </summary>
    RotateZ,
    /// <summary>
    /// ړ
    /// </summary>
    Move
};

/// <summary>
/// ̌^ύX
/// </summary>
public class TPOCommand
{
    internal TPOCommandType type;
    internal float x;
    internal float y;
    internal float z;

    /// ^Cv
    public TPOCommandType Type { get { return type; } }
    /// XWψ
    public float X { get { return x; } }
    /// YWψ
    public float Y { get { return y; } }
    /// ZWψ
    public float Z { get { return z; } }

    /// ψʃxNg𓾂܂B
    public Vector3 GetVector3()
    {
        return new Vector3(x, y, z);
    }
}

    /// <summary>
    /// bone܂B
    /// </summary>
public class TPONode
{
    private int id;
    private string name;
    private string sname;
    
    internal List<TPONode> children = new List<TPONode>();
    internal TPONode parent;

    /// <summary>
    /// ID
    /// </summary>
    public int ID { get { return id; } }
    /// <summary>
    /// 
    /// </summary>
    public string Name { get { return name; } }
    /// <summary>
    /// ́iZ`j
    /// </summary>
    public string ShortName { get { return sname; } }

    /// ό`샊Xg
    public List<TPOCommand> commands = new List<TPOCommand>();

    /// <summary>
    /// ό`ǉ܂B
    /// </summary>
    /// <param name="command"></param>
    public void AddCommand(TPOCommand command)
    {
        commands.Add(command);
    }
    
    /// <summary>
    /// ό`ǉ܂B
    /// </summary>
    /// <param name="type"></param>
    /// <param name="x"></param>
    /// <param name="y"></param>
    /// <param name="z"></param>
    public void AddCommand(TPOCommandType type, float x, float y, float z)
    {
        TPOCommand command = new TPOCommand();
        command.type = type;
        command.x = x;
        command.y = y;
        command.z = z;
        commands.Add(command);
    }
    
    /// <summary>
    /// TPONode𐶐܂B
    /// </summary>
    /// <param name="id"></param>
    /// <param name="name"></param>
    public TPONode(int id, string name)
    {
        this.id = id;
        this.name = name;
        this.sname = this.name.Substring(this.name.LastIndexOf('|') + 1);
    }

    /// <summary>
    /// [Vsw䗦ŕό`܂B
    /// </summary>
    /// <param name="mat">[Vs</param>
    /// <param name="ratio">䗦</param>
    public void Transform(TMOMat mat, float ratio)
    {
        foreach (TPOCommand command in commands)
        {
            Matrix scaling = Matrix.Identity;
            switch (command.type)
            {
                case TPOCommandType.Scale:
                case TPOCommandType.Scale1:
                case TPOCommandType.Scale0:
                    Vector3 v;
                    v.X = (float)Math.Pow(command.X, ratio);
                    v.Y = (float)Math.Pow(command.Y, ratio);
                    v.Z = (float)Math.Pow(command.Z, ratio);
                    scaling = Matrix.Scaling(v);
                    break;
            }
            switch (command.type)
            {
                case TPOCommandType.Scale:
                    mat.Scale(scaling);
                    break;
                case TPOCommandType.Scale1:
                    mat.Scale1(scaling);
                    break;
                case TPOCommandType.Scale0:
                    mat.Scale0(scaling);
                    break;
                case TPOCommandType.RotateX:
                    mat.RotateX(command.X * ratio);
                    break;
                case TPOCommandType.RotateY:
                    mat.RotateY(command.Y * ratio);
                    break;
                case TPOCommandType.RotateZ:
                    mat.RotateZ(command.Z * ratio);
                    break;
                case TPOCommandType.Move:
                    mat.Move(command.GetVector3() * ratio);
                    break;
            }
        }
    }

    /// <summary>
    /// g債܂B
    /// </summary>
    /// <param name="x"></param>
    /// <param name="y"></param>
    /// <param name="z"></param>
    public void Scale(float x, float y, float z)
    {
        AddCommand(TPOCommandType.Scale, x, y, z);
    }

    /// <summary>
    /// g債܂BɎqbone͂ꂼk܂B
    /// </summary>
    /// <param name="x"></param>
    /// <param name="y"></param>
    /// <param name="z"></param>
    public void Scale1(float x, float y, float z)
    {
        AddCommand(TPOCommandType.Scale1, x, y, z);

        foreach (TPONode child in children)
            child.Scale0(x, y, z);
    }

    /// <summary>
    /// k܂B
    /// </summary>
    /// <param name="x"></param>
    /// <param name="y"></param>
    /// <param name="z"></param>
    public void Scale0(float x, float y, float z)
    {
        AddCommand(TPOCommandType.Scale0, x, y, z);
    }

    /// <summary>
    /// X]s܂B
    /// </summary>
    /// <param name="angle"></param>
    public void RotateX(float angle)
    {
        AddCommand(TPOCommandType.RotateX, angle, 0, 0);
    }

    /// <summary>
    /// Y]s܂B
    /// </summary>
    /// <param name="angle"></param>
    public void RotateY(float angle)
    {
        AddCommand(TPOCommandType.RotateY, 0, angle, 0);
    }

    /// <summary>
    /// Z]s܂B
    /// </summary>
    /// <param name="angle"></param>
    public void RotateZ(float angle)
    {
        AddCommand(TPOCommandType.RotateZ, 0, 0, angle);
    }

    /// <summary>
    /// ړ܂B
    /// </summary>
    /// <param name="x"></param>
    /// <param name="y"></param>
    /// <param name="z"></param>
    public void Move(float x, float y, float z)
    {
        AddCommand(TPOCommandType.Move, x, y, z);
    }
}
}
